using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;

namespace W03ChatClient
{
    public partial class ClientForm : Form
    {
        public ClientForm()
        {
            InitializeComponent();
        }

        /// <summary>
        /// clientCX^X
        /// </summary>
        private TcpChatClient client;

        /// <summary>
        /// }EX{^
        /// </summary>
        private bool mouseB = false;

        /// <summary>
        /// F
        /// </summary>
        private Color lcolor = Color.White;

        /// <summary>
        /// y̑
        /// </summary>
        private float penFat = 2;

        /// <summary>
        /// ڑ
        /// </summary>
        private bool connected = false;

        /// <summary>
        /// GraphicsCX^X
        /// </summary>
        private Graphics g;

        /// <summary>
        /// n߉ӏ
        /// </summary>
        private int BackX = 0;
        private int BackY = 0;

        /// <summary>
        /// C[W
        /// </summary>
        private Bitmap defImage;

        private string name = string.Empty;
        delegate void msgDelegate();

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ClientForm_Load(object sender, EventArgs e)
        {
            try
            {
                TcpChatClient c = new TcpChatClient();
                //Cxgnh̒ǉ
                c.Connected += new EventHandler(c_Connected);
                c.Disconnected += new EventHandler(c_Disconnected);
                c.ReceivedData += new ReceivedDataEventHandler(c_ReceivedData);


                //T[o[TCg瓮IɕύXꍇiڑ˂j
                string url = @"zXgt@C̃pXݒ肵Ă";
                // NGXg̍쐬
                HttpWebRequest req = (HttpWebRequest)WebRequest.Create(url);
                req.Method = "GET";

                // X|X̎擾Ɠǂݍ
                WebResponse res = req.GetResponse();
                Stream resStream = res.GetResponseStream();
                StreamReader sr = new StreamReader(resStream, Encoding.GetEncoding("SHIFT-JIS"));

                string html = sr.ReadToEnd();

                sr.Close();
                resStream.Close();

                string[] hosts = html.Split(',');

                string host = hosts[0];
                int port = int.Parse(hosts[1].Trim());

                //ڃAhXݒ肷ꍇ
                //string host = "sarveraddress.com";
                //int port = 2345;

                //Oݒ
                name = System.Net.Dns.GetHostByName(System.Net.Dns.GetHostName()).AddressList[0].ToString();

                try
                {
                    //ڑ
                    c.Connect(host, port);
                }
                catch (Exception ex)
                {
                    c.Close();
                    MessageBox.Show("ڑɎs܂B\n(" + ex.Message + ")",
                        "G[",
                        MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                    this.Close();
                    return;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("ڑɎs܂B\n(" + ex.Message + ")",
                    "G[",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                this.Close();
            }
        }

        /// <summary>
        /// ̃f[^`
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void c_ReceivedData(object sender, ReceivedDataEventArgs e)
        {
            string[] cmds = e.ReceivedString.Split(' ');
            StringBuilder sb = new StringBuilder();

            if (cmds[0].Equals("MSG"))
            {
                try
                {
                    string[] datas = cmds[2].Split(',');

                    Color c = Color.FromArgb(int.Parse(datas[0].Trim()));
                    Pen pen = new Pen(c, float.Parse(datas[5]));
                    g.DrawLine(pen, int.Parse(datas[1]), int.Parse(datas[2]), int.Parse(datas[3]), int.Parse(datas[4]));

                    msgDelegate dlgt = new msgDelegate(ReDraw);
                    this.Invoke(dlgt);
                }
                catch
                {
                    
                }
            }
        }

        /// <summary>
        /// \XV
        /// </summary>
        void ReDraw()
        {
            pictureBox1.Image = defImage;
        }

        /// <summary>
        /// ؒf
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void c_Disconnected(object sender, EventArgs e)
        {
            this.client = null;
            connected = false; 
        }

        /// <summary>
        /// ڑ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void c_Connected(object sender, EventArgs e)
        {
            this.client = (TcpChatClient)sender;
            //this.Invoke(this.SetToConnected);
            connected = true;
            defImage = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            g = Graphics.FromImage(defImage);
            ReDraw();

            //`bgւ̎Qv
            string line = "JOIN " + name;
            this.client.Send(line);
        }


        /// <summary>
        /// ʉ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left && connected)
            {
                mouseB = true;
                BackX = e.X;
                BackY = e.Y;
            }
        }

        /// <summary>
        /// yړ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (mouseB)
            {
                Pen pen = null;
                pen = new Pen(lcolor, penFat);
                g.DrawLine(pen, BackX, BackY, e.X, e.Y);

                //bZ[WM
                this.client.SendMessage("MSG " + pen.Color.ToArgb().ToString() + "," + BackX.ToString() + "," + BackY.ToString() + "," + e.X.ToString() + "," + e.Y.ToString() + "," + penFat.ToString());

                BackX = e.X;
                BackY = e.Y;
                ReDraw();

            }
        }

        /// <summary>
        /// yꎞ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button != MouseButtons.Left)
            {
                mouseB = false;
            }
        }

        /// <summary>
        /// I{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void menuItem3_Click(object sender, EventArgs e)
        {
            try
            {
                this.client.Close();
                this.client.Dispose();
            }
            catch
            {

            }
            finally
            {
                this.Close();
            }
        }

        /// <summary>
        /// S`FbNIt
        /// </summary>
        private void offCheck()
        {
            Red.Checked = false;
            Blue.Checked = false;
            Yellow.Checked = false;
            Green.Checked = false;
            Black.Checked = false;
            White.Checked = false;

        }

        /// <summary>
        /// FI
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Color_Click(object sender, EventArgs e)
        {
            offCheck();
            ((MenuItem)sender).Checked = true;
            if (sender == Red)
                lcolor = Color.Red;
            else if (sender == Blue)
                lcolor = Color.Blue;
            else if (sender == Yellow)
                lcolor = Color.Yellow;
            else if (sender == Green)
                lcolor = Color.Green;
            else if (sender == White)
                lcolor = Color.White;
            else if (sender == Black)
                lcolor = Color.Black;
        }

        /// <summary>
        /// S`FbNIt
        /// </summary>
        private void offCheck2()
        {
            FatPen.Checked = false;
            NomalPen.Checked = false;
            ThinPen.Checked = false;
        }

        private void ThinSize_Click(object sender, EventArgs e)
        {
            offCheck2();
            ((MenuItem)sender).Checked = true;
            if (sender == FatPen)
                penFat = 8;
            else if (sender == NomalPen)
                penFat = 4;
            else if (sender == ThinPen)
                penFat = 2;
        }


    }
}